package com.link.core.util;

import com.link.base.enterprise.model.CoreEnterprise;
import com.link.base.user.model.CoreUser;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.CharArrayWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.security.AlgorithmParameters;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactory;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.Security;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import java.util.Arrays;
import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;
import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

public class PasswordUtil {
   private static boolean initialized = false;
   private static final Logger logger = LogManager.getLogger(PasswordUtil.class);
   private static final char[] HEX_CHAR = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};
   private static final String PRIVATE_KEY = "rsa/pkcs8_rsa_private_key.pem";
   private static final String PUBLIC_KEY = "rsa/rsa_public_key.pem";
   private static byte[] RSAcodes = new byte[256];
   private static char[] alphabet;
   private static byte[] codes;
   private static final String KEY_ALGORITHM = "AES";
   private static final String ALGORITHM = "AES/CBC/PKCS7Padding";
   private static Cipher cipher;
   private static Key key;

   public static String getMd5(String param) {
      String result = "Md5 exception";

      try {
         MessageDigest md5 = MessageDigest.getInstance("MD5");
         md5.update(param.getBytes("UTF-8"));
         byte[] b = md5.digest();
         StringBuffer buf = new StringBuffer("");

         for(int offset = 0; offset < b.length; ++offset) {
            int i = b[offset];
            if (i < 0) {
               i += 256;
            }

            if (i < 16) {
               buf.append("0");
            }

            buf.append(Integer.toHexString(i));
         }

         result = buf.toString().toUpperCase();
      } catch (NoSuchAlgorithmException var7) {
         var7.getStackTrace();
      } catch (UnsupportedEncodingException var8) {
         UnsupportedEncodingException e = var8;
         e.getStackTrace();
      }

      return result;
   }

   public static String loadPublicKeyByFile(String path) throws Exception {
      try {
         BufferedReader br = new BufferedReader(new FileReader(path + "rsa/rsa_public_key.pem"));
         Throwable var2 = null;

         try {
            String readLine = null;
            StringBuilder sb = new StringBuilder();

            while((readLine = br.readLine()) != null) {
               if (readLine.charAt(0) != '-') {
                  sb.append(readLine);
                  sb.append('\r');
               }
            }

            br.close();
            String var5 = sb.toString();
            return var5;
         } catch (Throwable var16) {
            var2 = var16;
            throw var16;
         } finally {
            if (br != null) {
               if (var2 != null) {
                  try {
                     br.close();
                  } catch (Throwable var15) {
                     var2.addSuppressed(var15);
                  }
               } else {
                  br.close();
               }
            }

         }
      } catch (IOException var18) {
         throw new Exception("公钥数据流读取错误");
      } catch (NullPointerException var19) {
         throw new Exception("公钥输入流为空");
      }
   }

   public static String loadPublicKeyStream() throws Exception {
      try {
         ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
         InputStream inputStream = classLoader.getResourceAsStream("rsa/rsa_public_key.pem");
         BufferedReader br = new BufferedReader(new InputStreamReader(inputStream));
         String readLine = null;
         StringBuilder sb = new StringBuilder();

         while((readLine = br.readLine()) != null) {
            if (readLine.charAt(0) != '-') {
               sb.append(readLine);
               sb.append('\r');
               System.out.println(readLine);
            }
         }

         return sb.toString();
      } catch (IOException var5) {
         throw new Exception("公钥数据读取错误");
      } catch (NullPointerException var6) {
         throw new Exception("公钥输入流为空");
      }
   }

   public static RSAPublicKey loadPublicKeyByStr() throws Exception {
      try {
         Resource resource = new ClassPathResource("rsa/rsa_public_key.pem");
         BASE64Decoder base64 = new BASE64Decoder();
         byte[] buffer = base64.decodeBuffer(((ClassPathResource)resource).getPath());
         KeyFactory keyFactory = KeyFactory.getInstance("RSA");
         X509EncodedKeySpec keySpec = new X509EncodedKeySpec(buffer);
         return (RSAPublicKey)keyFactory.generatePublic(keySpec);
      } catch (NoSuchAlgorithmException var5) {
         throw new Exception("无此算法");
      } catch (InvalidKeySpecException var6) {
         throw new Exception("公钥非法");
      } catch (NullPointerException var7) {
         throw new Exception("公钥数据为空");
      }
   }

   public static String loadPrivateKeyByFile() throws Exception {
      try {
         ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
         InputStream inputStream = classLoader.getResourceAsStream("rsa/pkcs8_rsa_private_key.pem");
         BufferedReader br = new BufferedReader(new InputStreamReader(inputStream));
         String readLine = null;
         StringBuilder sb = new StringBuilder();

         while((readLine = br.readLine()) != null) {
            if (readLine.charAt(0) != '-') {
               sb.append(readLine);
               sb.append('\r');
            }
         }

         br.close();
         return sb.toString();
      } catch (IOException var5) {
         throw new Exception("私钥数据读取错误");
      } catch (NullPointerException var6) {
         throw new Exception("私钥输入流为空");
      }
   }

   public static RSAPrivateKey loadPrivateKeyByStr(String privateKeyStr) throws Exception {
      try {
         BASE64Decoder base64Decoder = new BASE64Decoder();
         byte[] buffer = base64Decoder.decodeBuffer(privateKeyStr);
         PKCS8EncodedKeySpec keySpec = new PKCS8EncodedKeySpec(buffer);
         KeyFactory keyFactory = KeyFactory.getInstance("RSA");
         return (RSAPrivateKey)keyFactory.generatePrivate(keySpec);
      } catch (NoSuchAlgorithmException var5) {
         throw new Exception("无此算法");
      } catch (InvalidKeySpecException var6) {
         throw new Exception("私钥非法");
      } catch (NullPointerException var7) {
         throw new Exception("私钥数据为空");
      }
   }

   public static byte[] encryptPublicKey(RSAPublicKey publicKey, byte[] plainTextData) throws Exception {
      if (publicKey == null) {
         throw new Exception("加密公钥为空, 请设置");
      } else {
         Cipher cipher = null;

         try {
            cipher = Cipher.getInstance("RSA");
            cipher.init(1, publicKey);
            byte[] output = cipher.doFinal(plainTextData);
            return output;
         } catch (NoSuchAlgorithmException var4) {
            throw new Exception("无此加密算法");
         } catch (NoSuchPaddingException var5) {
            NoSuchPaddingException e = var5;
            logger.error("PasswordUtil捕获公钥加密过程中的异常: ", e);
            return null;
         } catch (InvalidKeyException var6) {
            throw new Exception("加密公钥非法,请检查");
         } catch (IllegalBlockSizeException var7) {
            throw new Exception("明文长度非法");
         } catch (BadPaddingException var8) {
            throw new Exception("明文数据已损坏");
         }
      }
   }

   public static byte[] encryptPrivateKey(RSAPrivateKey privateKey, byte[] plainTextData) throws Exception {
      if (privateKey == null) {
         throw new Exception("加密私钥为空, 请设置");
      } else {
         Cipher cipher = null;

         try {
            cipher = Cipher.getInstance("RSA");
            cipher.init(1, privateKey);
            byte[] output = cipher.doFinal(plainTextData);
            return output;
         } catch (NoSuchAlgorithmException var4) {
            throw new Exception("无此加密算法");
         } catch (NoSuchPaddingException var5) {
            NoSuchPaddingException e = var5;
            logger.error("PasswordUtil捕获私钥加密过程中的异常: ", e);
            return null;
         } catch (InvalidKeyException var6) {
            throw new Exception("加密私钥非法,请检查");
         } catch (IllegalBlockSizeException var7) {
            throw new Exception("明文长度非法");
         } catch (BadPaddingException var8) {
            throw new Exception("明文数据已损坏");
         }
      }
   }

   public static byte[] decryptPrivateKey(RSAPrivateKey privateKey, byte[] cipherData) throws Exception {
      if (privateKey == null) {
         throw new Exception("解密私钥为空, 请设置");
      } else {
         Cipher cipher = null;

         try {
            cipher = Cipher.getInstance("RSA");
            cipher.init(2, privateKey);
            byte[] output = cipher.doFinal(cipherData);
            return output;
         } catch (NoSuchAlgorithmException var4) {
            throw new Exception("无此解密算法");
         } catch (NoSuchPaddingException var5) {
            NoSuchPaddingException e = var5;
            logger.error("PasswordUtil捕获私钥解密过程中的异常: ", e);
            return null;
         } catch (InvalidKeyException var6) {
            throw new Exception("解密私钥非法,请检查");
         } catch (IllegalBlockSizeException var7) {
            throw new Exception("密文长度非法");
         } catch (BadPaddingException var8) {
            throw new Exception("密文数据已损坏");
         }
      }
   }

   public static byte[] decryptPublicKey(RSAPublicKey publicKey, byte[] cipherData) throws Exception {
      if (publicKey == null) {
         throw new Exception("解密公钥为空, 请设置");
      } else {
         Cipher cipher = null;

         try {
            cipher = Cipher.getInstance("RSA");
            cipher.init(2, publicKey);
            byte[] output = cipher.doFinal(cipherData);
            return output;
         } catch (NoSuchAlgorithmException var4) {
            throw new Exception("无此解密算法");
         } catch (NoSuchPaddingException var5) {
            NoSuchPaddingException e = var5;
            logger.error("PasswordUtil捕获公钥解密过程中的异常: ", e);
            return null;
         } catch (InvalidKeyException var6) {
            throw new Exception("解密公钥非法,请检查");
         } catch (IllegalBlockSizeException var7) {
            throw new Exception("密文长度非法");
         } catch (BadPaddingException var8) {
            throw new Exception("密文数据已损坏");
         }
      }
   }

   public static String byteArrayToString(byte[] data) {
      StringBuilder stringBuilder = new StringBuilder();

      for(int i = 0; i < data.length; ++i) {
         stringBuilder.append(HEX_CHAR[(data[i] & 240) >>> 4]);
         stringBuilder.append(HEX_CHAR[data[i] & 15]);
         if (i < data.length - 1) {
            stringBuilder.append(' ');
         }
      }

      return stringBuilder.toString();
   }

   public static String decryptString(String str) throws Exception {
      RSAPrivateKey privateKey = loadPrivateKeyByStr(loadPrivateKeyByFile());
      byte[] res = decryptPrivateKey(privateKey, RsadecodeStr(str));
      return new String(res);
   }

   public static byte[] RsadecodeStr(String data) {
      return RsadecodeChars(data.toCharArray());
   }

   public static byte[] RsadecodeChars(char[] data) {
      int tempLen = data.length;

      int len;
      for(len = 0; len < data.length; ++len) {
         if (data[len] > 255 || RSAcodes[data[len]] < 0) {
            --tempLen;
         }
      }

      len = tempLen / 4 * 3;
      if (tempLen % 4 == 3) {
         len += 2;
      }

      if (tempLen % 4 == 2) {
         ++len;
      }

      byte[] out = new byte[len];
      int shift = 0;
      int accum = 0;
      int index = 0;

      for(int ix = 0; ix < data.length; ++ix) {
         int value = data[ix] > 255 ? -1 : RSAcodes[data[ix]];
         if (value >= 0) {
            accum <<= 6;
            shift += 6;
            accum |= value;
            if (shift >= 8) {
               shift -= 8;
               out[index++] = (byte)(accum >> shift & 255);
            }
         }
      }

      if (index != out.length) {
         throw new Error("Miscalculated data length (wrote " + index + " instead of " + out.length + ")");
      } else {
         return out;
      }
   }

   public static String md5(String pwd) {
      String md5 = "";

      try {
         MessageDigest md = MessageDigest.getInstance("MD5");
         md.update(pwd.getBytes());
         byte[] b = md.digest();
         StringBuffer buf = new StringBuffer("");

         for(int offset = 0; offset < b.length; ++offset) {
            int count = b[offset];
            if (count < 0) {
               count += 256;
            }

            if (count < 16) {
               buf.append("0");
            }

            buf.append(Integer.toHexString(count));
         }

         md5 = buf.toString();
      } catch (NoSuchAlgorithmException var7) {
         NoSuchAlgorithmException e = var7;
         logger.error("PasswordUtil捕获异常: ", e);
      }

      return md5;
   }

   public static String parseStrToMd5L32(String str) {
      String reStr = null;

      try {
         MessageDigest md5 = MessageDigest.getInstance("MD5");
         byte[] bytes = md5.digest(str.getBytes());
         StringBuffer stringBuffer = new StringBuffer();
         byte[] var5 = bytes;
         int var6 = bytes.length;

         for(int var7 = 0; var7 < var6; ++var7) {
            byte b = var5[var7];
            int bt = b & 255;
            if (bt < 16) {
               stringBuffer.append(0);
            }

            stringBuffer.append(Integer.toHexString(bt));
         }

         reStr = stringBuffer.toString();
      } catch (NoSuchAlgorithmException var10) {
         NoSuchAlgorithmException e = var10;
         logger.error("PasswordUtil捕获异常: ", e);
      }

      return reStr;
   }

   public static String getBase64Encoder(String str) {
      byte[] bytes = null;
      String temp = null;

      try {
         bytes = str.getBytes("utf-8");
      } catch (Exception var4) {
         Exception e = var4;
         logger.error("PasswordUtil捕获异常: ", e);
      }

      if (bytes != null) {
         temp = (new BASE64Encoder()).encode(bytes);
      }

      return temp;
   }

   public static String getBase64Decoder(String str) {
      byte[] byteStr = null;
      String result = null;
      if (str != null) {
         BASE64Decoder decoder = new BASE64Decoder();

         try {
            byte[] byteStr = decoder.decodeBuffer(str);
            result = new String(byteStr, "utf-8");
         } catch (Exception var5) {
            Exception e = var5;
            logger.error("PasswordUtil捕获异常: ", e);
         }
      }

      return result;
   }

   public static String encodeStr(String data) {
      return new String(encodeBytes(data.getBytes()));
   }

   public static byte[] decodeStr(String data) {
      return decodeChars(data.toCharArray());
   }

   public static char[] encodeBytes(byte[] data) {
      char[] out = new char[(data.length + 2) / 3 * 4];
      int i = 0;

      for(int index = 0; i < data.length; index += 4) {
         boolean quad = false;
         boolean trip = false;
         int val = 255 & data[i];
         val <<= 8;
         if (i + 1 < data.length) {
            val |= 255 & data[i + 1];
            trip = true;
         }

         val <<= 8;
         if (i + 2 < data.length) {
            val |= 255 & data[i + 2];
            quad = true;
         }

         out[index + 3] = alphabet[quad ? val & 63 : 64];
         val >>= 6;
         out[index + 2] = alphabet[trip ? val & 63 : 64];
         val >>= 6;
         out[index + 1] = alphabet[val & 63];
         val >>= 6;
         out[index + 0] = alphabet[val & 63];
         i += 3;
      }

      return out;
   }

   public static byte[] decodeChars(char[] data) {
      int tempLen = data.length;

      int len;
      for(len = 0; len < data.length; ++len) {
         if (data[len] > 255 || codes[data[len]] < 0) {
            --tempLen;
         }
      }

      len = tempLen / 4 * 3;
      if (tempLen % 4 == 3) {
         len += 2;
      }

      if (tempLen % 4 == 2) {
         ++len;
      }

      byte[] out = new byte[len];
      int shift = 0;
      int accum = 0;
      int index = 0;

      for(int ix = 0; ix < data.length; ++ix) {
         int value = data[ix] > 255 ? -1 : codes[data[ix]];
         if (value >= 0) {
            accum <<= 6;
            shift += 6;
            accum |= value;
            if (shift >= 8) {
               shift -= 8;
               out[index++] = (byte)(accum >> shift & 255);
            }
         }
      }

      if (index != out.length) {
         throw new Error("Miscalculated data length (wrote " + index + " instead of " + out.length + ")");
      } else {
         return out;
      }
   }

   public static void encodeFile(File file) throws IOException {
      if (!file.exists()) {
         System.exit(0);
      } else {
         byte[] decoded = readBytes(file);
         if (encodeBytes(decoded) != null) {
            char[] encoded = encodeBytes(decoded);
            writeChars(file, encoded);
         }
      }

      file = null;
   }

   public static void decodeFile(File file) throws IOException {
      if (!file.exists()) {
         System.exit(0);
      } else {
         char[] encoded = readChars(file);
         byte[] decoded = decodeChars(encoded);
         writeBytes(file, decoded);
      }

      file = null;
   }

   private static byte[] readBytes(File file) throws IOException {
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      byte[] b = null;
      InputStream fis = new FileInputStream(file);
      Throwable var4 = null;

      try {
         InputStream is = new BufferedInputStream(fis);
         Throwable var6 = null;

         try {
            int count = false;
            byte[] buf = new byte[16384];

            int count;
            while((count = is.read(buf)) != -1) {
               if (count > 0) {
                  baos.write(buf, 0, count);
               }
            }

            b = baos.toByteArray();
         } catch (Throwable var30) {
            var6 = var30;
            throw var30;
         } finally {
            if (is != null) {
               if (var6 != null) {
                  try {
                     is.close();
                  } catch (Throwable var29) {
                     var6.addSuppressed(var29);
                  }
               } else {
                  is.close();
               }
            }

         }
      } catch (Throwable var32) {
         var4 = var32;
         throw var32;
      } finally {
         if (fis != null) {
            if (var4 != null) {
               try {
                  fis.close();
               } catch (Throwable var28) {
                  var4.addSuppressed(var28);
               }
            } else {
               fis.close();
            }
         }

      }

      return b;
   }

   private static char[] readChars(File file) throws IOException {
      CharArrayWriter caw = new CharArrayWriter();

      try {
         Reader fr = new FileReader(file);
         Throwable var3 = null;

         try {
            Reader in = new BufferedReader(fr);
            Throwable var5 = null;

            try {
               int count = false;
               char[] buf = new char[16384];

               int count;
               while((count = in.read(buf)) != -1) {
                  if (count > 0) {
                     caw.write(buf, 0, count);
                  }
               }
            } catch (Throwable var31) {
               var5 = var31;
               throw var31;
            } finally {
               if (in != null) {
                  if (var5 != null) {
                     try {
                        in.close();
                     } catch (Throwable var30) {
                        var5.addSuppressed(var30);
                     }
                  } else {
                     in.close();
                  }
               }

            }
         } catch (Throwable var33) {
            var3 = var33;
            throw var33;
         } finally {
            if (fr != null) {
               if (var3 != null) {
                  try {
                     fr.close();
                  } catch (Throwable var29) {
                     var3.addSuppressed(var29);
                  }
               } else {
                  fr.close();
               }
            }

         }
      } catch (Exception var35) {
         Exception e = var35;
         logger.error("PasswordUtil捕获异常: ", e);
      }

      return caw.toCharArray();
   }

   private static void writeBytes(File file, byte[] data) throws IOException {
      OutputStream fos = null;
      OutputStream os = null;

      try {
         fos = new FileOutputStream(file);
         os = new BufferedOutputStream(fos);
         os.write(data);
      } finally {
         try {
            if (os != null) {
               os.close();
            }

            if (fos != null) {
               fos.close();
            }
         } catch (Exception var10) {
            Exception e = var10;
            System.out.println(e);
         }

      }

   }

   private static void writeChars(File file, char[] data) throws IOException {
      Writer fos = null;
      Writer os = null;

      try {
         fos = new FileWriter(file);
         os = new BufferedWriter(fos);
         os.write(data);
      } finally {
         try {
            if (os != null) {
               os.close();
            }

            if (fos != null) {
               fos.close();
            }
         } catch (Exception var10) {
            Exception e = var10;
            logger.error("PasswordUtil捕获异常: ", e);
         }

      }

   }

   public static void init(byte[] keyBytes) {
      int base = 16;
      if (keyBytes.length % base != 0) {
         int groups = keyBytes.length / base + (keyBytes.length % base != 0 ? 1 : 0);
         byte[] temp = new byte[groups * base];
         Arrays.fill(temp, (byte)0);
         System.arraycopy(keyBytes, 0, temp, 0, keyBytes.length);
         keyBytes = temp;
      }

      if (!initialized) {
         Security.addProvider(new BouncyCastleProvider());
         initialized = true;
      }

      key = new SecretKeySpec(keyBytes, "AES");

      try {
         cipher = Cipher.getInstance("AES/CBC/PKCS7Padding");
      } catch (NoSuchAlgorithmException var4) {
         NoSuchAlgorithmException e = var4;
         logger.error("PasswordUtil捕获异常: ", e);
      } catch (NoSuchPaddingException var5) {
         NoSuchPaddingException e = var5;
         logger.error("PasswordUtil捕获异常: ", e);
      }

   }

   public static byte[] encrypt(byte[] content, byte[] keyBytes, byte[] ivBytes) {
      byte[] encryptedText = null;

      try {
         init(keyBytes);
         cipher.init(1, key, generateIV(ivBytes));
         encryptedText = cipher.doFinal(content);
      } catch (IllegalBlockSizeException var5) {
         IllegalBlockSizeException e = var5;
         logger.error("PasswordUtil捕获异常: ", e);
      } catch (BadPaddingException var6) {
         BadPaddingException e = var6;
         logger.error("PasswordUtil捕获异常: ", e);
      } catch (InvalidKeyException var7) {
         InvalidKeyException e = var7;
         logger.error("PasswordUtil捕获异常: ", e);
      } catch (InvalidAlgorithmParameterException var8) {
         InvalidAlgorithmParameterException e = var8;
         logger.error("PasswordUtil捕获异常: ", e);
      } catch (Exception var9) {
         Exception e = var9;
         logger.error("PasswordUtil捕获异常: ", e);
      }

      return encryptedText;
   }

   public static byte[] decrypt(byte[] encryptedData, byte[] keyBytes, byte[] ivBytes) throws InvalidAlgorithmParameterException {
      byte[] encryptedText = null;

      try {
         init(keyBytes);
         cipher.init(2, key, generateIV(ivBytes));
         encryptedText = cipher.doFinal(encryptedData);
      } catch (NoSuchAlgorithmException var5) {
         NoSuchAlgorithmException e = var5;
         logger.error("PasswordUtil捕获NoSuchAlgorithmException异常: ", e);
      } catch (NoSuchPaddingException var6) {
         NoSuchPaddingException e = var6;
         logger.error("PasswordUtil捕获NoSuchPaddingException异常: ", e);
      } catch (InvalidKeyException var7) {
         InvalidKeyException e = var7;
         logger.error("PasswordUtil捕获InvalidKeyException异常: ", e);
      } catch (IllegalBlockSizeException var8) {
         IllegalBlockSizeException e = var8;
         logger.error("PasswordUtil捕获IllegalBlockSizeException异常: ", e);
      } catch (BadPaddingException var9) {
         BadPaddingException e = var9;
         logger.error("PasswordUtil捕获BadPaddingException异常: ", e);
      } catch (NoSuchProviderException var10) {
         NoSuchProviderException e = var10;
         logger.error("PasswordUtil捕获NoSuchProviderException异常: ", e);
      } catch (Exception var11) {
         Exception e = var11;
         logger.error("PasswordUtil捕获异常: ", e);
      }

      return encryptedText;
   }

   public static AlgorithmParameters generateIV(byte[] iv) throws Exception {
      AlgorithmParameters params = AlgorithmParameters.getInstance("AES");
      params.init(new IvParameterSpec(iv));
      return params;
   }

   public static String getSHA256StrJava(String str) {
      String encodeStr = "";

      try {
         MessageDigest messageDigest = MessageDigest.getInstance("SHA-256");
         messageDigest.update(str.getBytes("UTF-8"));
         encodeStr = byte2Hex(messageDigest.digest());
      } catch (NoSuchAlgorithmException var4) {
         NoSuchAlgorithmException e = var4;
         logger.error("PasswordUtil捕获NoSuchAlgorithmException异常: ", e);
      } catch (UnsupportedEncodingException var5) {
         UnsupportedEncodingException e = var5;
         logger.error("PasswordUtil捕获UnsupportedEncodingException异常: ", e);
      }

      return encodeStr;
   }

   public static String getMD5StrJava(String str) {
      String encodeStr = "";

      try {
         MessageDigest messageDigest = MessageDigest.getInstance("MD5");
         messageDigest.update(str.getBytes("UTF-8"));
         encodeStr = byte2Hex(messageDigest.digest());
      } catch (NoSuchAlgorithmException var4) {
         NoSuchAlgorithmException e = var4;
         logger.error("NoSuchAlgorithmException: ", e);
      } catch (UnsupportedEncodingException var5) {
         UnsupportedEncodingException e = var5;
         logger.error("PasswordUtil捕获UnsupportedEncodingException异常: ", e);
      }

      return encodeStr;
   }

   private static String byte2Hex(byte[] bytes) {
      StringBuffer stringBuffer = new StringBuffer();
      String temp = null;

      for(int i = 0; i < bytes.length; ++i) {
         temp = Integer.toHexString(bytes[i] & 255);
         if (temp.length() == 1) {
            stringBuffer.append("0");
         }

         stringBuffer.append(temp);
      }

      return stringBuffer.toString();
   }

   public static String generatePwd(String str) {
      if (str != null && !"".equals(str)) {
         str = "123@!LINK" + str + "CRM";
         String shaStr = getSHA256StrJava(str);
         String md5Str = getMD5StrJava(shaStr);
         String result = "{LINKSHA}" + md5Str;
         return result;
      } else {
         return null;
      }
   }

   public static boolean isEquals(String pwd, String encodeStr) {
      if (pwd != null && encodeStr != null) {
         if (!encodeStr.startsWith("{LINKSHA}")) {
            return false;
         } else {
            pwd = generatePwd(pwd);
            return pwd != null ? pwd.equals(encodeStr) : false;
         }
      } else {
         return false;
      }
   }

   public static void checkPasswd(String pwd, CoreEnterprise enterprise, CoreUser user) throws Exception {
      Integer lenNum = enterprise.getPwMinLen();
      if (lenNum == null || lenNum == 0) {
         lenNum = 8;
      }

      if (lenNum < 6) {
         throw new Exception("密码长度小于6！");
      } else {
         String pwGrade = enterprise.getPwGrade();
         if ("".equals(pwGrade) || pwGrade == null) {
            pwGrade = "middle";
         }

         String regLow = "^.*[a-z]+.*$";
         String regNum = "^.*[0-9]+.*$";
         String regSCh = "^.*[/^/$/.//,;:'!@#%&/*/|/?/+/(/)/[/]/{/}]+.*$";
         String regMinNum = "^.{" + lenNum + ",}$";
         String regCapital = "^.*[A-Z]+.*$";
         if (!pwd.matches(regMinNum) && "refuse".equals(enterprise.getPwCheckGrade())) {
            throw new Exception("密码长度不符合要求，最小长度为：" + lenNum);
         } else {
            byte var11 = -1;
            switch (pwGrade.hashCode()) {
               case -1074341483:
                  if ("middle".equals(pwGrade)) {
                     var11 = 1;
                  }
                  break;
               case 3202466:
                  if ("high".equals(pwGrade)) {
                     var11 = 2;
                  }
                  break;
               case 103164673:
                  if ("lower".equals(pwGrade)) {
                     var11 = 0;
                  }
            }

            switch (var11) {
               case 0:
                  if (!pwd.matches(regLow) && !pwd.matches(regCapital) && "refuse".equals(enterprise.getPwCheckGrade())) {
                     throw new Exception("密码必须同时包含字母，数字！");
                  }

                  if (!pwd.matches(regNum) && "refuse".equals(enterprise.getPwCheckGrade())) {
                     throw new Exception("密码必须同时包含字母，数字！");
                  }
                  break;
               case 1:
                  if ((!pwd.matches(regLow) || !pwd.matches(regCapital)) && "refuse".equals(enterprise.getPwCheckGrade())) {
                     throw new Exception("密码必须同时包含大小写字母，数字！");
                  }

                  if (!pwd.matches(regNum) && "refuse".equals(enterprise.getPwCheckGrade())) {
                     throw new Exception("密码必须同时包含大小写字母，数字！");
                  }
                  break;
               case 2:
                  if ((!pwd.matches(regLow) || !pwd.matches(regCapital)) && "refuse".equals(enterprise.getPwCheckGrade())) {
                     throw new Exception("密码必须同时包含大小写字母，数字，特殊字符！");
                  }

                  if (!pwd.matches(regNum) && "refuse".equals(enterprise.getPwCheckGrade())) {
                     throw new Exception("密码必须同时包含大小写字母，数字，特殊字符！");
                  }

                  if (!pwd.matches(regSCh) && "refuse".equals(enterprise.getPwCheckGrade())) {
                     throw new Exception("密码必须同时包含大小写字母，数字，特殊字符！");
                  }
            }

         }
      }
   }

   public static String encryptBySHA1(String strSrc) {
      MessageDigest md = null;
      String strDes = null;
      byte[] bt = strSrc.getBytes();

      try {
         md = MessageDigest.getInstance("SHA-1");
         md.update(bt);
         strDes = StringUtils.bytes2Hex(md.digest());
         return strDes;
      } catch (NoSuchAlgorithmException var5) {
         return null;
      }
   }

   public static String encryptByMD5(String strSrc) {
      StringBuilder sb = new StringBuilder();

      try {
         MessageDigest md5 = MessageDigest.getInstance("MD5");
         md5.update(strSrc.getBytes());
         byte[] var8 = md5.digest();
         int var4 = var8.length;

         for(int var5 = 0; var5 < var4; ++var5) {
            byte b = var8[var5];
            sb.append(String.format("%02X", b));
         }

         return sb.toString();
      } catch (NoSuchAlgorithmException var7) {
         NoSuchAlgorithmException e = var7;
         logger.error("StringUtils捕获异常: ", e);
         return null;
      }
   }

   static {
      int i;
      for(i = 0; i < 256; ++i) {
         RSAcodes[i] = -1;
      }

      for(i = 65; i <= 90; ++i) {
         RSAcodes[i] = (byte)(i - 65);
      }

      for(i = 97; i <= 122; ++i) {
         RSAcodes[i] = (byte)(26 + i - 97);
      }

      for(i = 48; i <= 57; ++i) {
         RSAcodes[i] = (byte)(52 + i - 48);
      }

      RSAcodes[43] = 62;
      RSAcodes[47] = 63;
      alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".toCharArray();
      codes = new byte[256];

      for(i = 0; i < 256; ++i) {
         codes[i] = -1;
      }

      for(i = 65; i <= 90; ++i) {
         codes[i] = (byte)(i - 65);
      }

      for(i = 97; i <= 122; ++i) {
         codes[i] = (byte)(26 + i - 97);
      }

      for(i = 48; i <= 57; ++i) {
         codes[i] = (byte)(52 + i - 48);
      }

      codes[43] = 62;
      codes[47] = 63;
   }
}
